{# Template for main configuration file #}
#!{{ firewall_vars_nftables_bin }} -f
{{ ansible_managed | comment }}

# clean
flush ruleset

table inet firewall {

    chain inbound {
        type filter hook input priority 0; policy {{ 'accept' if firewall_config_inbound_policy == 'accept' else 'drop' }};

        ## Generic Rules ---------------------------------

        {% if firewall_config_inbound_allow_established_and_related | bool %}
        # Accept established and related packets
        ct state established,related accept

        {% endif %}
        {% if not firewall_config_inbound_allow_invalid | bool %}
        # Drop invalid packets
        ct state invalid drop

        {% endif %}
        {% if firewall_config_inbound_allow_loopback | bool %}
        # Accept all from localhost loopback
        iifname lo accept

        {% endif %}
        {% if firewall_config_inbound_allow_ping | bool %}
        # Accept ping
        ip protocol icmp limit rate 4/second accept
        ip6 nexthdr ipv6-icmp limit rate 4/second accept
        ip protocol igmp limit rate 4/second accept

        {% endif %}
        ## Rules -----------------------------------------

        {% if inbound_rules | length > 0 %}
        {% for rule in inbound_rules | gxmmx.linux._firewall_nftables_inbound %}
        # {{ rule.name}}
        {% for rule_line in rule.lines %}
        {{ rule_line }}
        {% endfor %}

        {% endfor %}
        {% else %}
        # None defined

        {% endif %}
        {% if firewall_config_inbound_raw | length > 0 %}
        ## Raw Rules -----------------------------------------

        {% for rule in firewall_config_inbound_raw %}
        {{ rule }}
        {% endfor %}

        {% endif %}

        {# {% include "bla.j2" %} #}

    }

    chain forward {
        type filter hook forward priority 0; policy {{ 'accept' if firewall_config_forward_policy == 'accept' else 'drop' }};

        # Role version does not support forwards

    }

    chain outbound {
        type filter hook output priority 0; policy {{ 'accept' if firewall_config_outbound_policy == 'accept' else 'drop' }};

        ## Rules -----------------------------------------

        {% if outbound_rules | length > 0 %}
        {% for rule in outbound_rules | gxmmx.linux._firewall_nftables_outbound %}
        # {{ rule.name}}
        {% for rule_line in rule.lines %}
        {{ rule_line }}
        {% endfor %}

        {% endfor %}
        {% else %}
        # None defined

        {% endif %}
        {% if firewall_config_outbound_raw | length > 0 %}
        ## Raw Rules -----------------------------------------

        {% for rule in firewall_config_outbound_raw %}
        {{ rule }}
        {% endfor %}

        {% endif %}
    }

}
